// components/web_package/mojom/web_bundle_parser.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "components/web_package/mojom/web_bundle_parser.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "components/web_package/mojom/web_bundle_parser.mojom-params-data.h"
namespace web_package {
namespace mojom {

static NOINLINE const char* BundleParseErrorTypeToStringHelper(BundleParseErrorType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case BundleParseErrorType::kParserInternalError:
      return "kParserInternalError";
    case BundleParseErrorType::kFormatError:
      return "kFormatError";
    case BundleParseErrorType::kVersionError:
      return "kVersionError";
    default:
      return nullptr;
  }
}

std::string BundleParseErrorTypeToString(BundleParseErrorType value) {
  const char *str = BundleParseErrorTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown BundleParseErrorType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, BundleParseErrorType value) {
  return os << BundleParseErrorTypeToString(value);
}

static NOINLINE const char* BundleFormatVersionToStringHelper(BundleFormatVersion value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case BundleFormatVersion::kB1:
      return "kB1";
    case BundleFormatVersion::kB2:
      return "kB2";
    default:
      return nullptr;
  }
}

std::string BundleFormatVersionToString(BundleFormatVersion value) {
  const char *str = BundleFormatVersionToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown BundleFormatVersion value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, BundleFormatVersion value) {
  return os << BundleFormatVersionToString(value);
}

namespace internal {


// static
bool BundleIntegrityBlockParseError_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleIntegrityBlockParseError_Data* object =
      static_cast<const BundleIntegrityBlockParseError_Data*>(data);


  if (!::web_package::mojom::internal::BundleParseErrorType_Data
        ::Validate(object->type, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->message, validation_context,
                                         &message_validate_params)) {
    return false;
  }

  return true;
}

BundleIntegrityBlockParseError_Data::BundleIntegrityBlockParseError_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleMetadataParseError_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleMetadataParseError_Data* object =
      static_cast<const BundleMetadataParseError_Data*>(data);


  if (!::web_package::mojom::internal::BundleParseErrorType_Data
        ::Validate(object->type, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->message, validation_context,
                                         &message_validate_params)) {
    return false;
  }

  return true;
}

BundleMetadataParseError_Data::BundleMetadataParseError_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleResponseParseError_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleResponseParseError_Data* object =
      static_cast<const BundleResponseParseError_Data*>(data);


  if (!::web_package::mojom::internal::BundleParseErrorType_Data
        ::Validate(object->type, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->message, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->message, validation_context,
                                         &message_validate_params)) {
    return false;
  }

  return true;
}

BundleResponseParseError_Data::BundleResponseParseError_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleIntegrityBlock_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleIntegrityBlock_Data* object =
      static_cast<const BundleIntegrityBlock_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->signature_stack, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams signature_stack_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->signature_stack, validation_context,
                                         &signature_stack_validate_params)) {
    return false;
  }

  return true;
}

BundleIntegrityBlock_Data::BundleIntegrityBlock_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleIntegrityBlockSignatureStackEntry_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleIntegrityBlockSignatureStackEntry_Data* object =
      static_cast<const BundleIntegrityBlockSignatureStackEntry_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->complete_entry_cbor, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams complete_entry_cbor_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->complete_entry_cbor, validation_context,
                                         &complete_entry_cbor_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->attributes_cbor, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams attributes_cbor_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->attributes_cbor, validation_context,
                                         &attributes_cbor_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->public_key, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams public_key_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->public_key, validation_context,
                                         &public_key_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->signature, 4, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams signature_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->signature, validation_context,
                                         &signature_validate_params)) {
    return false;
  }

  return true;
}

BundleIntegrityBlockSignatureStackEntry_Data::BundleIntegrityBlockSignatureStackEntry_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleMetadata_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleMetadata_Data* object =
      static_cast<const BundleMetadata_Data*>(data);


  if (!::web_package::mojom::internal::BundleFormatVersion_Data
        ::Validate(object->version, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->primary_url, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->primary_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->requests, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams requests_validate_params(
      new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
  if (!mojo::internal::ValidateContainer(object->requests, validation_context,
                                         &requests_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->authorities, 4, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams authorities_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->authorities, validation_context,
                                         &authorities_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->vouched_subsets, 5, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams vouched_subsets_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->vouched_subsets, validation_context,
                                         &vouched_subsets_validate_params)) {
    return false;
  }

  return true;
}

BundleMetadata_Data::BundleMetadata_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleResponseLocation_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleResponseLocation_Data* object =
      static_cast<const BundleResponseLocation_Data*>(data);

  return true;
}

BundleResponseLocation_Data::BundleResponseLocation_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AugmentedCertificate_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AugmentedCertificate_Data* object =
      static_cast<const AugmentedCertificate_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->cert, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams cert_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->cert, validation_context,
                                         &cert_validate_params)) {
    return false;
  }

  const mojo::internal::ContainerValidateParams ocsp_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->ocsp, validation_context,
                                         &ocsp_validate_params)) {
    return false;
  }

  const mojo::internal::ContainerValidateParams sct_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->sct, validation_context,
                                         &sct_validate_params)) {
    return false;
  }

  return true;
}

AugmentedCertificate_Data::AugmentedCertificate_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool VouchedSubset_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const VouchedSubset_Data* object =
      static_cast<const VouchedSubset_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->sig, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams sig_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->sig, validation_context,
                                         &sig_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->raw_signed, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams raw_signed_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->raw_signed, validation_context,
                                         &raw_signed_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->parsed_signed, 4, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->parsed_signed, validation_context))
    return false;

  return true;
}

VouchedSubset_Data::VouchedSubset_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SignedSubset_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SignedSubset_Data* object =
      static_cast<const SignedSubset_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->validity_url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->validity_url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->auth_sha256, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams auth_sha256_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->auth_sha256, validation_context,
                                         &auth_sha256_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->subset_hashes, 5, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams subset_hashes_validate_params(
      new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
  if (!mojo::internal::ValidateContainer(object->subset_hashes, validation_context,
                                         &subset_hashes_validate_params)) {
    return false;
  }

  return true;
}

SignedSubset_Data::SignedSubset_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SubsetHashesValue_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SubsetHashesValue_Data* object =
      static_cast<const SubsetHashesValue_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->variants_value, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams variants_value_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->variants_value, validation_context,
                                         &variants_value_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->resource_integrities, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams resource_integrities_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->resource_integrities, validation_context,
                                         &resource_integrities_validate_params)) {
    return false;
  }

  return true;
}

SubsetHashesValue_Data::SubsetHashesValue_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ResourceIntegrity_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ResourceIntegrity_Data* object =
      static_cast<const ResourceIntegrity_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->header_sha256, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams header_sha256_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->header_sha256, validation_context,
                                         &header_sha256_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->payload_integrity_header, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams payload_integrity_header_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->payload_integrity_header, validation_context,
                                         &payload_integrity_header_validate_params)) {
    return false;
  }

  return true;
}

ResourceIntegrity_Data::ResourceIntegrity_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleResponse_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleResponse_Data* object =
      static_cast<const BundleResponse_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->response_headers, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams response_headers_validate_params(
      new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)), new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)));
  if (!mojo::internal::ValidateContainer(object->response_headers, validation_context,
                                         &response_headers_validate_params)) {
    return false;
  }

  return true;
}

BundleResponse_Data::BundleResponse_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParserFactory_GetParserForFile_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParserFactory_GetParserForFile_Params_Data* object =
      static_cast<const WebBundleParserFactory_GetParserForFile_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->file, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->file, validation_context))
    return false;

  return true;
}

WebBundleParserFactory_GetParserForFile_Params_Data::WebBundleParserFactory_GetParserForFile_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParserFactory_GetParserForDataSource_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParserFactory_GetParserForDataSource_Params_Data* object =
      static_cast<const WebBundleParserFactory_GetParserForDataSource_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->data_source, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->data_source,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WebBundleParserFactory_GetParserForDataSource_Params_Data::WebBundleParserFactory_GetParserForDataSource_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseIntegrityBlock_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseIntegrityBlock_Params_Data* object =
      static_cast<const WebBundleParser_ParseIntegrityBlock_Params_Data*>(data);

  return true;
}

WebBundleParser_ParseIntegrityBlock_Params_Data::WebBundleParser_ParseIntegrityBlock_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseIntegrityBlock_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseIntegrityBlock_ResponseParams_Data* object =
      static_cast<const WebBundleParser_ParseIntegrityBlock_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->Result, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->error, validation_context))
    return false;

  return true;
}

WebBundleParser_ParseIntegrityBlock_ResponseParams_Data::WebBundleParser_ParseIntegrityBlock_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseMetadata_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseMetadata_Params_Data* object =
      static_cast<const WebBundleParser_ParseMetadata_Params_Data*>(data);

  return true;
}

WebBundleParser_ParseMetadata_Params_Data::WebBundleParser_ParseMetadata_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseMetadata_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseMetadata_ResponseParams_Data* object =
      static_cast<const WebBundleParser_ParseMetadata_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->Result, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->error, validation_context))
    return false;

  return true;
}

WebBundleParser_ParseMetadata_ResponseParams_Data::WebBundleParser_ParseMetadata_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseResponse_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseResponse_Params_Data* object =
      static_cast<const WebBundleParser_ParseResponse_Params_Data*>(data);

  return true;
}

WebBundleParser_ParseResponse_Params_Data::WebBundleParser_ParseResponse_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebBundleParser_ParseResponse_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebBundleParser_ParseResponse_ResponseParams_Data* object =
      static_cast<const WebBundleParser_ParseResponse_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->Result, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->error, validation_context))
    return false;

  return true;
}

WebBundleParser_ParseResponse_ResponseParams_Data::WebBundleParser_ParseResponse_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_Read_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_Read_Params_Data* object =
      static_cast<const BundleDataSource_Read_Params_Data*>(data);

  return true;
}

BundleDataSource_Read_Params_Data::BundleDataSource_Read_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_Read_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_Read_ResponseParams_Data* object =
      static_cast<const BundleDataSource_Read_ResponseParams_Data*>(data);

  const mojo::internal::ContainerValidateParams buffer_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->buffer, validation_context,
                                         &buffer_validate_params)) {
    return false;
  }

  return true;
}

BundleDataSource_Read_ResponseParams_Data::BundleDataSource_Read_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_Length_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_Length_Params_Data* object =
      static_cast<const BundleDataSource_Length_Params_Data*>(data);

  return true;
}

BundleDataSource_Length_Params_Data::BundleDataSource_Length_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_Length_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_Length_ResponseParams_Data* object =
      static_cast<const BundleDataSource_Length_ResponseParams_Data*>(data);

  return true;
}

BundleDataSource_Length_ResponseParams_Data::BundleDataSource_Length_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_IsRandomAccessContext_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_IsRandomAccessContext_Params_Data* object =
      static_cast<const BundleDataSource_IsRandomAccessContext_Params_Data*>(data);

  return true;
}

BundleDataSource_IsRandomAccessContext_Params_Data::BundleDataSource_IsRandomAccessContext_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool BundleDataSource_IsRandomAccessContext_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const BundleDataSource_IsRandomAccessContext_ResponseParams_Data* object =
      static_cast<const BundleDataSource_IsRandomAccessContext_ResponseParams_Data*>(data);

  return true;
}

BundleDataSource_IsRandomAccessContext_ResponseParams_Data::BundleDataSource_IsRandomAccessContext_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace web_package

namespace perfetto {

// static
void TraceFormatTraits<::web_package::mojom::BundleParseErrorType>::WriteIntoTrace(
   perfetto::TracedValue context, ::web_package::mojom::BundleParseErrorType value) {
  return std::move(context).WriteString(::web_package::mojom::BundleParseErrorTypeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::web_package::mojom::BundleFormatVersion>::WriteIntoTrace(
   perfetto::TracedValue context, ::web_package::mojom::BundleFormatVersion value) {
  return std::move(context).WriteString(::web_package::mojom::BundleFormatVersionToString(value));
}

} // namespace perfetto