// extensions/common/mojom/event_router.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_SHARED_H_
#define EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "extensions/common/mojom/event_router.mojom-shared-internal.h"
#include "mojo/public/mojom/base/values.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace extensions {
namespace mojom {
class EventListenerParamDataView;


}  // namespace mojom
}  // namespace extensions

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::extensions::mojom::EventListenerParamDataView> {
  using Data = ::extensions::mojom::internal::EventListenerParam_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace extensions {
namespace mojom {
// Interface base classes. They are used for type safety check.
class EventRouterInterfaceBase {};

using EventRouterPtrDataView =
    mojo::InterfacePtrDataView<EventRouterInterfaceBase>;
using EventRouterRequestDataView =
    mojo::InterfaceRequestDataView<EventRouterInterfaceBase>;
using EventRouterAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<EventRouterInterfaceBase>;
using EventRouterAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<EventRouterInterfaceBase>;


class EventListenerParamDataView {
 public:
  using Tag = internal::EventListenerParam_Data::EventListenerParam_Tag;

  EventListenerParamDataView() = default;

  EventListenerParamDataView(
      internal::EventListenerParam_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_extension_id() const { return data_->tag == Tag::kExtensionId; }
  inline void GetExtensionIdDataView(
      mojo::StringDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadExtensionId(UserType* output) const {
    
    CHECK(is_extension_id());
    return mojo::internal::Deserialize<mojo::StringDataView>(
        data_->data.f_extension_id.Get(), output, message_);
  }
  bool is_listener_url() const { return data_->tag == Tag::kListenerUrl; }
  inline void GetListenerUrlDataView(
      ::url::mojom::UrlDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadListenerUrl(UserType* output) const {
    
    CHECK(is_listener_url());
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        data_->data.f_listener_url.Get(), output, message_);
  }

 private:
  internal::EventListenerParam_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace extensions

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::extensions::mojom::EventListenerParamDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::extensions::mojom::EventListenerParamDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::extensions::mojom::internal::EventListenerParam_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::extensions::mojom::EventListenerParamDataView::Tag::kExtensionId: {
        decltype(Traits::extension_id(input))
            in_extension_id = Traits::extension_id(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_extension_id)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<mojo::StringDataView>(
            in_extension_id, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null extension_id in EventListenerParam union");
        fragment->data.f_extension_id.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::extensions::mojom::EventListenerParamDataView::Tag::kListenerUrl: {
        decltype(Traits::listener_url(input))
            in_listener_url = Traits::listener_url(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_listener_url)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::url::mojom::UrlDataView>(
            in_listener_url, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null listener_url in EventListenerParam union");
        fragment->data.f_listener_url.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::extensions::mojom::internal::EventListenerParam_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::extensions::mojom::EventListenerParamDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace extensions {
namespace mojom {

inline void EventListenerParamDataView::GetExtensionIdDataView(
    mojo::StringDataView* output) const {
  CHECK(is_extension_id());
  *output = mojo::StringDataView(data_->data.f_extension_id.Get(), message_);
}
inline void EventListenerParamDataView::GetListenerUrlDataView(
    ::url::mojom::UrlDataView* output) const {
  CHECK(is_listener_url());
  *output = ::url::mojom::UrlDataView(data_->data.f_listener_url.Get(), message_);
}


}  // namespace mojom
}  // namespace extensions

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // EXTENSIONS_COMMON_MOJOM_EVENT_ROUTER_MOJOM_SHARED_H_