// services/data_decoder/public/mojom/web_bundler.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DATA_DECODER_PUBLIC_MOJOM_WEB_BUNDLER_MOJOM_H_
#define SERVICES_DATA_DECODER_PUBLIC_MOJOM_WEB_BUNDLER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/data_decoder/public/mojom/web_bundler.mojom-shared.h"
#include "services/data_decoder/public/mojom/web_bundler.mojom-forward.h"
#include "services/data_decoder/public/mojom/resource_snapshot_for_web_bundle.mojom-forward.h"
#include "mojo/public/mojom/base/file.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace data_decoder {
namespace mojom {

class WebBundlerProxy;

template <typename ImplRefTraits>
class WebBundlerStub;

class WebBundlerRequestValidator;
class WebBundlerResponseValidator;


class  WebBundler
    : public WebBundlerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebBundlerInterfaceBase;
  using Proxy_ = WebBundlerProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebBundlerStub<ImplRefTraits>;

  using RequestValidator_ = WebBundlerRequestValidator;
  using ResponseValidator_ = WebBundlerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGenerateMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Generate_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebBundler() = default;


  using GenerateCallback = base::OnceCallback<void(uint64_t, WebBundlerError)>;
  
  virtual void Generate(std::vector<::mojo::PendingRemote<::data_decoder::mojom::ResourceSnapshotForWebBundle>> snapshots, ::base::File file, GenerateCallback callback) = 0;
};



class  WebBundlerProxy
    : public WebBundler {
 public:
  using InterfaceType = WebBundler;

  explicit WebBundlerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Generate(std::vector<::mojo::PendingRemote<::data_decoder::mojom::ResourceSnapshotForWebBundle>> snapshots, ::base::File file, GenerateCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebBundlerStubDispatch {
 public:
  static bool Accept(WebBundler* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebBundler* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebBundler>>
class WebBundlerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebBundlerStub() = default;
  ~WebBundlerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebBundlerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebBundlerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebBundlerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebBundlerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace data_decoder

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_DATA_DECODER_PUBLIC_MOJOM_WEB_BUNDLER_MOJOM_H_